local metadata = {
"## Interface:FS15 1.2",
"## Title: UniversalManipulate",
"## Notes: Manipuliert LS15 Werte",
"## Author: HappyLooser",
"## Version: 0.4",
"## Date: Begin 3.1.2015",
"## Web: no",
"## Info: Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt"
} 

print("---loading UniversalManipulate v0.4 (by HappyLooser)---")
local manipulateType = "";
local groupTag = "UniversalManipulate.";
local groupType = "";
local groupSpecification = "";
local groupPath = "";
local acceptTypes = "";
local automaticSettings = "";
local allFruitTypes = "";
local manipulateLogTypes = "";
local Xml;
local accpetsManipulationNames = "Trailer,Sowing,Shovel,Cutter,Sprayer,Combine";

function loadConfig()
	local path = getUserProfileAppPath();
	local file = path.."/universalManipulateSettings.xml";
	local firstStart = true;	
	local acceptsNamesSplit = Utils.splitString(",", accpetsManipulationNames);
	if fileExists(file) then
		print("loading "..file.." for UniversalManipulate settings");		
		Xml = loadXMLFile("universalManipulateSettings_XML", file, "UniversalManipulate");		
		if getXMLBool(Xml, "UniversalManipulate.Config.AutomaticCompletion") == nil then
			setXMLBool(Xml, "UniversalManipulate.Config.AutomaticCompletion", false);
		end;
		for _,v in pairs(acceptsNamesSplit) do
			if string.len(v) >= 2 and getXMLBool(Xml, "UniversalManipulate.Config.Manipulate"..v.."s") == nil then			
				setXMLBool(Xml, "UniversalManipulate.Config.Manipulate"..v.."s", false);
			end;			
		end;
		print("----Universal Manipulate: update Phantom_.... accepts values----");
		createPhantomAndAcceptsNew(acceptsNamesSplit);				
		firstStart = false;
	else
		print("creating "..file.." for UniversalManipulate settings");
		Xml = createXMLFile("UniversalManipulateSettings_XML", file, "UniversalManipulate");		
		setXMLBool(Xml, "UniversalManipulate.Config.AutomaticCompletion", true);
		for _,v in pairs(acceptsNamesSplit) do
			if string.len(v) >= 2 then				
				setXMLBool(Xml, "UniversalManipulate.Config.Manipulate"..v.."s", false);				
			end;
		end;		
		createPhantomAndAcceptsNew(acceptsNamesSplit);
	end;
	saveXMLFile(Xml);	
	Xml = loadXMLFile("universalManipulateSettings_XML", file, "UniversalManipulate");
	if not firstStart and not getXMLBool(Xml, "UniversalManipulate.Config.AutomaticCompletion") then
		setManipulation(acceptsNamesSplit);
	else
		print("----UniversalManipulate is not active !! Is first start or AutomaticCompletion is true !!!----");
	end;
end;

function createPhantomAndAcceptsNew(acceptsNamesSplit)	
	local groupAccepts = "Config.GroupNames."
	setXMLString(Xml, groupTag.. groupAccepts.."AutomaticCompletionName", "here ..... name");
	setXMLString(Xml, groupTag.. groupAccepts.."Names", "Phantom Name,");	
	setXMLString(Xml, groupTag.. groupAccepts.."Phantom_Name.fillTypesFruit", "fruitName,fruitName,allFruit,");
	setXMLString(Xml, groupTag.. groupAccepts.."Phantom_Name.fillTypesFill", "fruitName,fruitName,");
	setXMLString(Xml, groupTag.. groupAccepts.."Phantom_Name.seedFruitTypes", "fruitName,fruitName,");
	setXMLString(Xml, groupTag.. groupAccepts.."Phantom_Name.fruitTypes", "fruitName,fruitName,");
	setXMLInt(Xml, groupTag.. groupAccepts.."Phantom_Name.capacity", 0);
	setXMLInt(Xml, groupTag.. groupAccepts.."Phantom_Name.overloadingCapacity", 0);
	setXMLInt(Xml, groupTag.. groupAccepts.."Phantom_Name.fuelCapacity", 0);
	setXMLInt(Xml, groupTag.. groupAccepts.."Phantom_Name.fuelUsage", 0);
	setXMLBool(Xml, groupTag.. groupAccepts.."Phantom_Name.useDirectPlanting", false);
	setXMLFloat(Xml, groupTag.. groupAccepts.."Phantom_Name.sprayLitersPerSecond", 0.0);
	if getXMLBool(Xml, "UniversalManipulate.Config.AutomaticCompletion") then
		for _,v in pairs(acceptsNamesSplit) do
			groupType = v .."s.";		
			local completionNames = getXMLString(Xml, groupTag.. groupType.."AutomaticCompletionName");
			if completionNames == nil then
				setXMLString(Xml, groupTag.. groupType.."AutomaticCompletionName", "here " ..v .." name");
			elseif string.find(completionNames, "here " ..v .." name") == nil then
				automaticSettings = getXMLString(Xml, groupTag.. groupType.."AutomaticCompletionName");				
				automaticCompletionSettingsNew(v, automaticSettings ..",");				
			end;		
		end;
	end;
	saveXMLFile(Xml);	
end;

function automaticCompletionSettingsNew(typeName, automaticSettingsName)
	local automatic = Utils.splitString(",", automaticSettingsName);
	local settingsOkay = false;
	local autoName = "";
	groupType = typeName .."s.";	
	local settingsNames = getXMLString(Xml, groupTag.. groupType.."Names");
	for _,k in pairs(automatic) do		
		if k ~= nil and string.len(k) >= 2 and k ~= "here "..typeName.." name" then			
			local new = false;
			if settingsNames == nil then				
				setXMLString(Xml, groupTag.. groupType.."Names", k ..",");
				new = true;
				saveXMLFile(Xml);
			end;
			settingsNames = getXMLString(Xml, groupTag.. groupType.."Names");
			if new or string.find(settingsNames ..",", k ..",") == nil then
				local replaceName = string.gsub(k, " ", "_");				
				autoName = autoName .." " ..k					
				setXMLString(Xml, groupTag.. groupType.. replaceName..".fillTypesFruit", "fruitName,fruitName,allFruit,");
				setXMLString(Xml, groupTag.. groupType.. replaceName..".fillTypesFill", "fruitName,fruitName,");
				setXMLString(Xml, groupTag.. groupType.. replaceName..".seedFruitTypes", "fruitName,fruitName,");
				setXMLString(Xml, groupTag.. groupType.. replaceName..".fruitTypes", "fruitName,fruitName,");
				setXMLInt(Xml, groupTag.. groupType.. replaceName..".capacity", 0);			
				setXMLInt(Xml, groupTag.. groupType.. replaceName..".overloadingCapacity", 0);
				setXMLInt(Xml, groupTag.. groupType.. replaceName..".fuelCapacity", 0);
				setXMLInt(Xml, groupTag.. groupType.. replaceName..".fuelUsage", 0);
				setXMLBool(Xml, groupTag.. groupType.. replaceName..".useDirectPlanting", false);							
				setXMLFloat(Xml, groupTag.. groupType.. replaceName..".sprayLitersPerSecond", 0.0);								
				if not new then
					setXMLString(Xml, groupTag.. groupType.."Names", k.."," ..settingsNames);
				end;
				settingsOkay = true;				
			end;
		end;
	end;
	setXMLString(Xml, groupTag.. groupType.."AutomaticCompletionName", "here " ..typeName .." name");
	if settingsOkay then
		print("----generate automatic completion settings for names:" ..autoName .."----");	
	end;
end;

function setManipulation(acceptsNamesSplit)
	for _,v in pairs(acceptsNamesSplit) do
		if string.len(v) >= 2 and getXMLBool(Xml, "UniversalManipulate.Config.Manipulate"..v.."s") then
			if v == "Trailer" then TrailerManipulation();end;
			if v == "Sowing" then SowingManipulation();end;
			if v == "Shovel" then ShovelManipulation();end
			if v == "Cutter" then CutterManipulation();end;
			if v == "Sprayer" then SprayerManipulation();end;
			if v == "Combine" then CombineManipulation();end;
		end;	
	end;
	--PlaceableManipulation()
end;

function TrailerManipulation()	
	local oldTrailerLoad = Trailer.load;	
	Trailer.load = function(self, xmlFile)	
		oldTrailerLoad(self, xmlFile);
		groupType = "Trailers.";
		manipulateType = getXMLString(Xml, groupTag.. groupType.."Names");
		local found = false;
		if self.name ~= nil and checkAll(1, self.name, false) then			
			local replaceName = checkAll(2, self.name, false);					
			found = true;
			if replaceName ~= nil then				
				setAll(self, xmlFile, replaceName, "Trailer", ".capacity,.overloadingCapacity,.fillTypesFruit");							
			end;		
		end;
		if not found then
			found = false
			local oldWaterTrailerLoad = WaterTrailer.load;	
				WaterTrailer.load = function(self, xmlFile)	
				oldWaterTrailerLoad(self, xmlFile);
				groupType = "Trailers.";
				manipulateType = getXMLString(Xml, groupTag.. groupType.."Names");
				if self.name ~= nil and checkAll(1, self.name, false) then			
					found = true;
					local replaceName = checkAll(2, self.name, false);					
					if replaceName ~= nil then
						setAll(self, xmlFile, replaceName, "Trailer", ".capacity,.overloadingCapacity,.fillTypesFill");							
					end;		
				end;
			end;
		end;		
		if not found then
			found = false
			local oldFuelTrailerLoad = FuelTrailer.load;	
				FuelTrailer.load = function(self, xmlFile)	
				oldFuelTrailerLoad(self, xmlFile);
				groupType = "Trailers.";
				manipulateType = getXMLString(Xml, groupTag.. groupType.."Names");
				if self.name ~= nil and checkAll(1, self.name, false) then
					local replaceName = checkAll(2, self.name, false);					
					if replaceName ~= nil then
						setAll(self, xmlFile, replaceName, "Trailer", ".capacity,.overloadingCapacity,.fillTypesFill");							
					end;		
				end;		
			end;
		end;				
	end;		
end;

function SowingManipulation()	
	local oldSowingMachineLoad = SowingMachine.load;	
	SowingMachine.load = function(self, xmlFile)	
		oldSowingMachineLoad(self, xmlFile);
		groupType = "Sowings.";
		manipulateType = getXMLString(Xml, groupTag.. groupType.."Names");
		if self.name ~= nil and checkAll(1, self.name, false) then			
			local replaceName = checkAll(2, self.name, false);					
			if replaceName ~= nil then				
				setAll(self, xmlFile, replaceName, "Sowing", ".capacity,.fillTypesFill,.useDirectPlanting,.seedFruitTypes");				
			end;		
		end;	
	end;	
end;

function ShovelManipulation()	
	local oldShovelLoad = Shovel.load;	
	Shovel.load = function(self, xmlFile)	
		oldShovelLoad(self, xmlFile);
		groupType = "Shovels.";
		manipulateType = getXMLString(Xml, groupTag.. groupType.."Names");		
		if self.name ~= nil and checkAll(1, self.name, false) then			
			local replaceName = checkAll(2, self.name, false);					
			if replaceName ~= nil then
				setAll(self, xmlFile, replaceName, "Shovel", ".capacity,.fillTypesFruit");							
			end;		
		end;	
	end;	
end;

function CutterManipulation()	
	local oldCutterLoad = Cutter.load;	
	Cutter.load = function(self, xmlFile)	
		oldCutterLoad(self, xmlFile);
		groupType = "Cutters.";
		manipulateType = getXMLString(Xml, groupTag.. groupType.."Names");			
		if self.name ~= nil and checkAll(1, self.name, false) then
			local replaceName = checkAll(2, self.name, false);					
			if replaceName ~= nil then
				setAll(self, xmlFile, replaceName, "Cutter", ".fruitTypes");
			end;		
		end;	
	end;	
end;

function SprayerManipulation()	
	local oldSprayerLoad = Sprayer.load;	
	Sprayer.load = function(self, xmlFile)	
		oldSprayerLoad(self, xmlFile);
		groupType = "Sprayers.";
		manipulateType = getXMLString(Xml, groupTag.. groupType.."Names");		
		if self.name ~= nil and checkAll(1, self.name, false) then
			local replaceName = checkAll(2, self.name, false);					
			if replaceName ~= nil then
				setAll(self, xmlFile, replaceName, "Sprayer", ".capacity,.fillTypesFill");							
			end;		
		end;	
	end;	
end;

function CombineManipulation()	
	local oldCombineLoad = Combine.load;	
	Combine.load = function(self, xmlFile)	
		oldCombineLoad(self, xmlFile);				
		groupType = "Combines.";
		manipulateType = getXMLString(Xml, groupTag.. groupType.."Names");		
		if self.name ~= nil and checkAll(1, self.name, false) then			
			local replaceName = checkAll(2, self.name, false);					
			if replaceName ~= nil then
				setAll(self, xmlFile, replaceName, "Combine", ".capacity,.fillTypesFill,.overloadingCapacity,.fuelCapacity,.fuelUsage");				
			end;		
		end;		
	end;	
end;

function checkAll(int, manipulate, typesExtra)	
	if int == 1 and manipulateType ~= nil and string.find(manipulateType ..",", manipulate ..",", 0, true) ~= nil then		
		return true;
	end;
	if int == 2 then		
		return string.gsub(manipulate, " ", "_");
	end;
	if int == 3 then
		return groupTag ..groupType ..manipulate ..groupSpecification		
	end;	
	return false;
end;

function setAll(self, xmlFile, replaceName, groupTypeName, groupTypes)	
	if string.find(groupTypes, ".capacity") ~= nil then
		groupSpecification = ".capacity";
		groupPath = checkAll(3, replaceName, false);
		groupSpecification = getXMLInt(Xml, groupPath);	
		if self.capacity ~= nil and groupSpecification ~= nil and groupSpecification > 0 then				
			self.capacity = groupSpecification;						
		end;		
	end;
	if string.find(groupTypes, ".overloadingCapacity") ~= nil then
		groupSpecification = ".overloadingCapacity";
		groupPath = checkAll(3, replaceName, false);
		groupSpecification = getXMLInt(Xml, groupPath);	
		if self.overloadingCapacity ~= nil and groupSpecification ~= nil and groupSpecification > 0 then 
			self.overloadingCapacity = groupSpecification;						
		end;		
	end;
	if string.find(groupTypes, ".fuelCapacity") ~= nil then
		groupSpecification = ".fuelCapacity";
		groupPath = checkAll(3, replaceName, false);
		groupSpecification = getXMLInt(Xml, groupPath);	
		if self.fuelCapacity ~= nil and groupSpecification ~= nil and groupSpecification > 0 then 
			self.fuelCapacity = groupSpecification;						
		end;
	end;
	if string.find(groupTypes, ".fuelUsage") ~= nil then
		groupSpecification = ".fuelUsage";
		groupPath = checkAll(3, replaceName, false);
		groupSpecification = getXMLInt(Xml, groupPath);	
		if self.fuelUsage ~= nil and groupSpecification ~= nil and groupSpecification > 0 then 
			self.fuelUsage = groupSpecification;						
		end;		
	end;
	if string.find(groupTypes, ".useDirectPlanting") ~= nil then
		groupSpecification = ".useDirectPlanting";
		groupPath = checkAll(3, replaceName, false);
		groupSpecification = getXMLBool(Xml, groupPath);	
		if self.useDirectPlanting ~= nil and groupSpecification ~= nil and groupSpecification then 
			self.useDirectPlanting = groupSpecification;						
		end;		
	end;
	if string.find(groupTypes, ".fillTypesFruit") ~= nil then
		groupSpecification = ".fillTypesFruit";
		groupPath = checkAll(3, replaceName, false);
		if getXMLString(Xml, groupPath) ~= nil then
			local XMLString = getXMLString(Xml, groupPath)
			if string.find(XMLString ..",", "allFruit,") ~= nil then				
				fruitAll(self, xmlFile, 1)
				acceptTypes = Utils.splitString(" ", allFruitTypes);
			else
				acceptTypes = Utils.splitString(",", XMLString);
			end;			
			if acceptTypes ~= nil and string.len(XMLString) >= 2 then				
				for _,v in pairs(acceptTypes) do					
					if string.len(v) >= 2 then
						local fillType = Fillable.fillTypeNameToInt[v];							
						if fillType ~= nil and self.fillTypes[fillType] == nil then
							self.fillTypes[fillType] = true;												
						end;											
					end;					
				end;				
			end;			
		end;
	end;	
	if string.find(groupTypes, ".fillTypesFill") ~= nil then
		groupSpecification = ".fillTypesFill";
		groupPath = checkAll(3, replaceName, false);
		if getXMLString(Xml, groupPath) ~= nil then
			local XMLString = getXMLString(Xml, groupPath)			
			--if string.find(XMLString ..",", "allFruit,") ~= nil then				
			--	fruitAll(self, xmlFile, 2)
			--	acceptTypes = Utils.splitString(" ", allFruitTypes);
			--else
				acceptTypes = Utils.splitString(",", XMLString);
			--end;			
			if acceptTypes ~= nil and string.len(XMLString) >= 2 then				
				for _,v in pairs(acceptTypes) do					
					if string.len(v) >= 2 then
						local fillType = Fillable.fillTypeNameToInt[v];							
						if fillType ~= nil and self.fillTypes[fillType] == nil then
							self.fillTypes[fillType] = true;
							if groupTypeName == "Combine" then									
								local fruitType = FruitUtil.fruitTypes[v];
								if fruitType ~= nil then									
									local outputDesc = v;
									self.convertedFruits[fruitType.index] = outputDesc.index;
								end;
							end;							
							if groupTypeName == "Sprayer" then							
								local underGroupSpecification = ".sprayLitersPerSecond";
								local underGroupPath = groupTag ..groupType ..replaceName ..underGroupSpecification	
								if underGroupPath ~= nil then								
									local underGroupSpecification = getXMLFloat(Xml, underGroupPath);	
									if underGroupSpecification ~= nil and underGroupSpecification > 0 then									
										self.sprayLitersPerSecond[fillType] = underGroupSpecification;
									end;
								end;
								if self.defaultSprayLitersPerSecond == nil then								
									self.defaultSprayLitersPerSecond = 0;
								end;
							end;
						elseif groupTypeName == "Sprayer" and fillType ~= nil and self.fillTypes[fillType] ~= nil then
							local underGroupSpecification = ".sprayLitersPerSecond";
							local underGroupPath = groupTag ..groupType ..replaceName ..underGroupSpecification	
							if underGroupPath ~= nil then									
								local underGroupSpecification = getXMLFloat(Xml, underGroupPath);	
								if underGroupSpecification ~= nil and underGroupSpecification > 0 then
									self.sprayLitersPerSecond[fillType] = underGroupSpecification;
								end;
							end;
							if self.defaultSprayLitersPerSecond == nil then
								self.defaultSprayLitersPerSecond = 0;
							end;					
						end;											
					end;					
				end;				
			end;			
		end;
	end;	
	if string.find(groupTypes, ".seedFruitTypes") ~= nil then
		groupSpecification = ".seedFruitTypes";
		groupPath = checkAll(3, replaceName, false);
		if getXMLString(Xml, groupPath) ~= nil then
			local XMLString = getXMLString(Xml, groupPath)
			acceptTypes = Utils.splitString(",", XMLString);
			if acceptTypes ~= nil and string.len(XMLString) >= 2 then
				for _,v in pairs(acceptTypes) do
					if string.len(v) >= 2 then						
						local fruitTypeDesc = FruitUtil.fruitTypes[v];
						if fruitTypeDesc ~= nil and self.seeds[fruitTypeDesc] == nil and v ~= fruitTypeDesc.index then
							table.insert(self.seeds, FruitUtil.fruitTypes[v].index);								
						end;
					end;
				end;
			end;
		end;
	end;
	if string.find(groupTypes, ".fruitTypes") ~= nil then
		groupSpecification = ".fruitTypes";
		groupPath = checkAll(3, replaceName, false);				
		if getXMLString(Xml, groupPath) ~= nil then
			local XMLString = getXMLString(Xml, groupPath)
			acceptTypes = Utils.splitString(",", XMLString);
			if acceptTypes ~= nil and string.len(XMLString) >= 2 then
				for _,v in pairs(acceptTypes) do
					if string.len(v) >= 2 then						
						local fruitType = FruitUtil.fruitTypes[v];
						if fruitType ~= nil and self.fruitTypes[fruitType] == nil then								
							table.insert(self.fruitTypes, FruitUtil.fruitTypes[v].index);
							self.fruitTypes[fruitType.index] = true;
							local outputDesc = "chaff";
							self.convertedFruits[fruitType.index] = outputDesc.index;								
						end;
					end;
				end;
			end;
		end;
	end;
end;

function fruitAll(self, xmlFile, int)
	if int == 1 then		
		local fillTypes = getXMLString(xmlFile, "vehicle.fillTypes#fruitTypes");
		allFruitTypes = fillTypes;		
		for i=1,Fillable.NUM_FILLTYPES do
			local desc = Fillable.fillTypeIndexToDesc[i];
			local name = desc.name;									
			if string.find(fillTypes .." ", name .." ") == nil then								
				allFruitTypes = allFruitTypes .." "..name;							
			end;
		end;
	end;
	if int == 2 then		
		local fillTypes = getXMLString(xmlFile, "vehicle.fillTypes#fillTypes");
		allFruitTypes = fillTypes;		
		for i=1,Fillable.NUM_FILLTYPES do
			local desc = Fillable.fillTypeIndexToDesc[i];
			local name = desc.name;									
			if string.find(fillTypes .." ", name .." ") == nil then								
				allFruitTypes = allFruitTypes .." "..name;
				--local fruitTypeDesc = FruitUtil.fruitTypes[name];							
				--local fillType = Fillable.fillTypeNameToInt[name];
				--if fruitTypeDesc ~= nil and fillTypes ~= nil then
					
					--self.fillTypes[fillType] = true;
					--table.insert(self.fillTypes, FruitUtil.fruitTypes[name].index);
				--end;				
			end;
		end;
	end;
end;
loadConfig()
--print("sprung:")